/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Contents of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.134 - (hide annotations) (download)
Sun Apr 5 08:22:29 2009 UTC (5 years, 5 months ago) by grobian
Branch: MAIN
Changes since 1.133: +1 -7 lines
remove the Darwin hook, it seemingly has been obsoleted

1 vapier 1.129 # Copyright 1999-2009 Gentoo Foundation
2 verwilst 1.1 # Distributed under the terms of the GNU General Public License v2
3 grobian 1.134 # $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.133 2009/04/04 17:57:54 grobian Exp $
4 vapier 1.121
5     # @ECLASS: flag-o-matic.eclass
6     # @MAINTAINER:
7     # toolchain@gentoo.org
8     # @BLURB: common functions to manipulate and query toolchain flags
9     # @DESCRIPTION:
10     # This eclass contains a suite of functions to help developers sanely
11     # and safely manage toolchain flags in their builds.
12 vapier 1.63
13 eradicator 1.80 inherit eutils toolchain-funcs multilib
14 vapier 1.72
15 kevquinn 1.92 ################ DEPRECATED functions ################
16     # The following are still present to avoid breaking existing
17     # code more than necessary; however they are deprecated. Please
18     # use gcc-specs-* from toolchain-funcs.eclass instead, if you
19     # need to know which hardened techs are active in the compiler.
20     # See bug #100974
21     #
22 vapier 1.121 # has_hardened
23     # has_pie
24     # has_pic
25     # has_ssp_all
26     # has_ssp
27    
28 verwilst 1.3
29 dberkholz 1.124 # {C,CXX,F,FC}FLAGS that we allow in strip-flags
30 vapier 1.117 # Note: shell globs and character lists are allowed
31 vapier 1.36 setup-allowed-flags() {
32 vapier 1.84 if [[ -z ${ALLOWED_FLAGS} ]] ; then
33 vapier 1.76 export ALLOWED_FLAGS="-pipe"
34     export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
35 vapier 1.87 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
36 solar 1.127 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking -fno-strict-overflow"
37 kevquinn 1.105 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
38 vapier 1.117 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
39 vapier 1.107 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
40 dberkholz 1.120 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -W* -w"
41 vapier 1.44 fi
42 vapier 1.65 # allow a bunch of flags that negate features / control ABI
43 vapier 1.119 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \
44 solar 1.127 -fno-strict-aliasing -fno-bounds-checking -fstrict-overflow"
45 vapier 1.87 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
46     -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
47     -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
48     -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
49 vapier 1.110 -mieee -mieee-with-inexact -mschedule \
50 vapier 1.91 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
51 vapier 1.87 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
52     -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
53 vapier 1.114 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
54 solar 1.127 -msecure-plt -m*-toc -D* -U*"
55 grobian 1.133
56 dberkholz 1.124 # {C,CXX,F,FC}FLAGS that we are think is ok, but needs testing
57 vapier 1.36 # NOTE: currently -Os have issues with gcc3 and K6* arch's
58 vapier 1.106 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
59 vapier 1.36 return 0
60 aliz 1.24 }
61 verwilst 1.13
62 kevquinn 1.105 # inverted filters for hardened compiler. This is trying to unpick
63     # the hardened compiler defaults.
64     _filter-hardened() {
65     local f
66     for f in "$@" ; do
67     case "${f}" in
68     # Ideally we should only concern ourselves with PIE flags,
69     # not -fPIC or -fpic, but too many places filter -fPIC without
70     # thinking about -fPIE.
71     -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
72     gcc-specs-pie || continue
73     is-flagq -nopie || append-flags -nopie;;
74     -fstack-protector)
75     gcc-specs-ssp || continue
76 gengor 1.131 is-flagq -fno-stack-protector || append-flags $(test-flags -fno-stack-protector);;
77 kevquinn 1.105 -fstack-protector-all)
78     gcc-specs-ssp-to-all || continue
79 gengor 1.131 is-flagq -fno-stack-protector-all || append-flags $(test-flags -fno-stack-protector-all);;
80 gengor 1.128 -fno-strict-overflow)
81     gcc-specs-nostrict || continue
82 gengor 1.131 is-flagq -fstrict-overflow || append-flags $(test-flags -fstrict-overflow);;
83 solar 1.27 esac
84     done
85 kevquinn 1.105 }
86    
87     # Remove occurrences of strings from variable given in $1
88     # Strings removed are matched as globs, so for example
89     # '-O*' would remove -O1, -O2 etc.
90     _filter-var() {
91     local f x VAR VAL
92     declare -a new
93 vapier 1.36
94 kevquinn 1.105 VAR=$1
95     shift
96     eval VAL=\${${VAR}}
97     for f in ${VAL}; do
98     for x in "$@"; do
99     # Note this should work with globs like -O*
100     [[ ${f} == ${x} ]] && continue 2
101 agriffis 1.61 done
102 kevquinn 1.105 eval new\[\${\#new\[@]}]=\${f}
103 verwilst 1.1 done
104 kevquinn 1.105 eval export ${VAR}=\${new\[*]}
105     }
106 agriffis 1.61
107 vapier 1.121 # @FUNCTION: filter-flags
108     # @USAGE: <flags>
109     # @DESCRIPTION:
110 dberkholz 1.124 # Remove particular <flags> from {C,CPP,CXX,F,FC}FLAGS. Accepts shell globs.
111 kevquinn 1.105 filter-flags() {
112     _filter-hardened "$@"
113     _filter-var CFLAGS "$@"
114 vapier 1.118 _filter-var CPPFLAGS "$@"
115 kevquinn 1.105 _filter-var CXXFLAGS "$@"
116 dberkholz 1.124 _filter-var FFLAGS "$@"
117     _filter-var FCFLAGS "$@"
118 vapier 1.36 return 0
119 verwilst 1.2 }
120    
121 vapier 1.121 # @FUNCTION: filter-lfs-flags
122     # @DESCRIPTION:
123     # Remove flags that enable Large File Support.
124 vapier 1.40 filter-lfs-flags() {
125 vapier 1.93 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
126 vapier 1.40 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
127     }
128    
129 vapier 1.121 # @FUNCTION: append-cppflags
130     # @USAGE: <flags>
131     # @DESCRIPTION:
132     # Add extra <flags> to the current CPPFLAGS.
133 vapier 1.118 append-cppflags() {
134     [[ -z $* ]] && return 0
135     export CPPFLAGS="${CPPFLAGS} $*"
136     return 0
137     }
138    
139 gengor 1.132 # @FUNCTION: append-cxxflags
140     # @USAGE: <flags>
141     # @DESCRIPTION:
142     # Add extra <flags> to the current CXXFLAGS.
143     append-cxxflags() {
144     [[ -z $* ]] && return 0
145     export CXXFLAGS="${CXXFLAGS} $*"
146     return 0
147     }
148    
149 dberkholz 1.124 # @FUNCTION: append-fflags
150     # @USAGE: <flags>
151     # @DESCRIPTION:
152     # Add extra <flags> to the current {F,FC}FLAGS.
153     append-fflags() {
154     [[ -z $* ]] && return 0
155     export FFLAGS="${FFLAGS} $*"
156     export FCFLAGS="${FCFLAGS} $*"
157     return 0
158     }
159    
160 vapier 1.121 # @FUNCTION: append-lfs-flags
161     # @DESCRIPTION:
162     # Add flags that enable Large File Support.
163 vapier 1.48 append-lfs-flags() {
164 vapier 1.93 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
165 vapier 1.118 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
166 vapier 1.48 }
167    
168 vapier 1.121 # @FUNCTION: append-flags
169     # @USAGE: <flags>
170     # @DESCRIPTION:
171 dberkholz 1.124 # Add extra <flags> to your current {C,CXX,F,FC}FLAGS.
172 vapier 1.18 append-flags() {
173 solar 1.82 [[ -z $* ]] && return 0
174 agriffis 1.58 export CFLAGS="${CFLAGS} $*"
175     export CXXFLAGS="${CXXFLAGS} $*"
176 dberkholz 1.124 export FFLAGS="${FFLAGS} $*"
177     export FCFLAGS="${FCFLAGS} $*"
178 vapier 1.28 return 0
179 verwilst 1.1 }
180    
181 vapier 1.121 # @FUNCTION: replace-flags
182     # @USAGE: <old> <new>
183     # @DESCRIPTION:
184     # Replace the <old> flag with <new>. Accepts shell globs for <old>.
185 vapier 1.18 replace-flags() {
186 vapier 1.93 [[ $# != 2 ]] \
187     && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
188     && die "replace-flags takes 2 arguments, not $#"
189    
190 mr_bones_ 1.83 local f fset
191 dirtyepic 1.125 declare -a new_CFLAGS new_CXXFLAGS new_FFLAGS new_FCFLAGS
192 agriffis 1.64
193 dberkholz 1.124 for fset in CFLAGS CXXFLAGS FFLAGS FCFLAGS; do
194 agriffis 1.64 # Looping over the flags instead of using a global
195     # substitution ensures that we're working with flag atoms.
196     # Otherwise globs like -O* have the potential to wipe out the
197     # list of flags.
198     for f in ${!fset}; do
199     # Note this should work with globs like -O*
200     [[ ${f} == ${1} ]] && f=${2}
201     eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
202     done
203     eval export ${fset}=\${new_${fset}\[*]}
204     done
205    
206 vapier 1.28 return 0
207 danarmak 1.7 }
208    
209 vapier 1.121 # @FUNCTION: replace-cpu-flags
210     # @USAGE: <old> <new>
211     # @DESCRIPTION:
212     # Replace cpu flags (like -march/-mcpu/-mtune) that select the <old> cpu
213     # with flags that select the <new> cpu. Accepts shell globs for <old>.
214 vapier 1.37 replace-cpu-flags() {
215 vapier 1.70 local newcpu="$#" ; newcpu="${!newcpu}"
216     while [ $# -gt 1 ] ; do
217 agriffis 1.64 # quote to make sure that no globbing is done (particularly on
218 vapier 1.113 # ${oldcpu}) prior to calling replace-flags
219 vapier 1.70 replace-flags "-march=${1}" "-march=${newcpu}"
220     replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
221     replace-flags "-mtune=${1}" "-mtune=${newcpu}"
222     shift
223 vapier 1.37 done
224     return 0
225     }
226    
227 vapier 1.113 _is_flagq() {
228 kevquinn 1.105 local x
229 vapier 1.113 for x in ${!1} ; do
230     [[ ${x} == $2 ]] && return 0
231 kevquinn 1.105 done
232     return 1
233     }
234    
235 vapier 1.121 # @FUNCTION: is-flagq
236     # @USAGE: <flag>
237     # @DESCRIPTION:
238 dberkholz 1.124 # Returns shell true if <flag> is in {C,CXX,F,FC}FLAGS, else returns shell false. Accepts shell globs.
239 vapier 1.113 is-flagq() {
240     [[ -n $2 ]] && die "Usage: is-flag <flag>"
241 dberkholz 1.124 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1 || _is_flagq FFLAGS $1 || _is_flagq FCFLAGS $1
242 vapier 1.113 }
243    
244 vapier 1.121 # @FUNCTION: is-flag
245     # @USAGE: <flag>
246     # @DESCRIPTION:
247 dberkholz 1.124 # Echo's "true" if flag is set in {C,CXX,F,FC}FLAGS. Accepts shell globs.
248 danarmak 1.7 is-flag() {
249 vapier 1.113 is-flagq "$@" && echo true
250 kevquinn 1.105 }
251    
252 vapier 1.121 # @FUNCTION: is-ldflagq
253     # @USAGE: <flag>
254     # @DESCRIPTION:
255     # Returns shell true if <flag> is in LDFLAGS, else returns shell false. Accepts shell globs.
256 kevquinn 1.105 is-ldflagq() {
257 vapier 1.113 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
258     _is_flagq LDFLAGS $1
259 verwilst 1.1 }
260 azarah 1.8
261 vapier 1.121 # @FUNCTION: is-ldflag
262     # @USAGE: <flag>
263     # @DESCRIPTION:
264     # Echo's "true" if flag is set in LDFLAGS. Accepts shell globs.
265 kevquinn 1.105 is-ldflag() {
266 vapier 1.113 is-ldflagq "$@" && echo true
267 kevquinn 1.105 }
268    
269 vapier 1.121 # @FUNCTION: filter-mfpmath
270     # @USAGE: <math types>
271     # @DESCRIPTION:
272     # Remove specified math types from the fpmath flag. For example, if the user
273     # has -mfpmath=sse,386, running `filter-mfpmath sse` will leave the user with
274     # -mfpmath=386.
275 vapier 1.36 filter-mfpmath() {
276 agriffis 1.58 local orig_mfpmath new_math prune_math
277    
278 vapier 1.36 # save the original -mfpmath flag
279 vapier 1.109 orig_mfpmath=$(get-flag -mfpmath)
280 vapier 1.36 # get the value of the current -mfpmath flag
281 vapier 1.109 new_math=$(get-flag mfpmath)
282     new_math=" ${new_math//,/ } "
283 vapier 1.36 # figure out which math values are to be removed
284 agriffis 1.58 prune_math=""
285 vapier 1.36 for prune_math in "$@" ; do
286 vapier 1.109 new_math=${new_math/ ${prune_math} / }
287 vapier 1.36 done
288 vapier 1.109 new_math=$(echo ${new_math})
289     new_math=${new_math// /,}
290 vapier 1.36
291 vapier 1.109 if [[ -z ${new_math} ]] ; then
292 vapier 1.36 # if we're removing all user specified math values are
293     # slated for removal, then we just filter the flag
294     filter-flags ${orig_mfpmath}
295     else
296     # if we only want to filter some of the user specified
297     # math values, then we replace the current flag
298     replace-flags ${orig_mfpmath} -mfpmath=${new_math}
299     fi
300     return 0
301     }
302    
303 vapier 1.121 # @FUNCTION: strip-flags
304     # @DESCRIPTION:
305     # Strip C[XX]FLAGS of everything except known good/safe flags.
306 azarah 1.8 strip-flags() {
307 dberkholz 1.124 local x y flag NEW_CFLAGS NEW_CXXFLAGS NEW_FFLAGS NEW_FCFLAGS
308 agriffis 1.58
309 vapier 1.36 setup-allowed-flags
310    
311 azarah 1.8 local NEW_CFLAGS=""
312     local NEW_CXXFLAGS=""
313 dberkholz 1.124 local NEW_FFLAGS=""
314     local NEW_FCFLAGS=""
315 azarah 1.8
316 azarah 1.17 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
317 vapier 1.84 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
318 azarah 1.17 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
319     fi
320    
321 agriffis 1.58 set -f # disable pathname expansion
322 azarah 1.8
323 agriffis 1.58 for x in ${CFLAGS}; do
324     for y in ${ALLOWED_FLAGS}; do
325 lostlogic 1.14 flag=${x%%=*}
326 vapier 1.65 if [ "${flag%%${y}}" = "" ] ; then
327 lostlogic 1.14 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
328     break
329 azarah 1.8 fi
330     done
331     done
332    
333 agriffis 1.58 for x in ${CXXFLAGS}; do
334     for y in ${ALLOWED_FLAGS}; do
335 lostlogic 1.14 flag=${x%%=*}
336 vapier 1.65 if [ "${flag%%${y}}" = "" ] ; then
337 lostlogic 1.14 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
338     break
339 azarah 1.8 fi
340     done
341     done
342 azarah 1.30
343 dberkholz 1.124 for x in ${FFLAGS}; do
344     for y in ${ALLOWED_FLAGS}; do
345     flag=${x%%=*}
346     if [ "${flag%%${y}}" = "" ] ; then
347     NEW_FFLAGS="${NEW_FFLAGS} ${x}"
348     break
349     fi
350     done
351     done
352    
353     for x in ${FCFLAGS}; do
354     for y in ${ALLOWED_FLAGS}; do
355     flag=${x%%=*}
356     if [ "${flag%%${y}}" = "" ] ; then
357     NEW_FCFLAGS="${NEW_FCFLAGS} ${x}"
358     break
359     fi
360     done
361     done
362    
363 azarah 1.30 # In case we filtered out all optimization flags fallback to -O2
364     if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then
365     NEW_CFLAGS="${NEW_CFLAGS} -O2"
366     fi
367     if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then
368     NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2"
369     fi
370 dberkholz 1.124 if [ "${FFLAGS/-O}" != "${FFLAGS}" -a "${NEW_FFLAGS/-O}" = "${NEW_FFLAGS}" ]; then
371     NEW_FFLAGS="${NEW_FFLAGS} -O2"
372     fi
373     if [ "${FCFLAGS/-O}" != "${FCFLAGS}" -a "${NEW_FCFLAGS/-O}" = "${NEW_FCFLAGS}" ]; then
374     NEW_FCFLAGS="${NEW_FCFLAGS} -O2"
375     fi
376 azarah 1.8
377 agriffis 1.58 set +f # re-enable pathname expansion
378 azarah 1.8
379     export CFLAGS="${NEW_CFLAGS}"
380     export CXXFLAGS="${NEW_CXXFLAGS}"
381 dberkholz 1.124 export FFLAGS="${NEW_FFLAGS}"
382     export FCFLAGS="${NEW_FCFLAGS}"
383 vapier 1.36 return 0
384 puggy 1.29 }
385    
386 azarah 1.96 test-flag-PROG() {
387     local comp=$1
388     local flags="$2"
389    
390     [[ -z ${comp} || -z ${flags} ]] && \
391     return 1
392    
393     local PROG=$(tc-get${comp})
394     ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
395     > /dev/null 2>&1
396     }
397    
398 vapier 1.121 # @FUNCTION: test-flag-CC
399     # @USAGE: <flag>
400     # @DESCRIPTION:
401     # Returns shell true if <flag> is supported by the C compiler, else returns shell false.
402 azarah 1.96 test-flag-CC() { test-flag-PROG "CC" "$1"; }
403    
404 vapier 1.121 # @FUNCTION: test-flag-CXX
405     # @USAGE: <flag>
406     # @DESCRIPTION:
407     # Returns shell true if <flag> is supported by the C++ compiler, else returns shell false.
408 azarah 1.96 test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
409    
410 dberkholz 1.124 # @FUNCTION: test-flag-F77
411     # @USAGE: <flag>
412     # @DESCRIPTION:
413     # Returns shell true if <flag> is supported by the Fortran 77 compiler, else returns shell false.
414     test-flag-F77() { test-flag-PROG "F77" "$1"; }
415    
416     # @FUNCTION: test-flag-FC
417     # @USAGE: <flag>
418     # @DESCRIPTION:
419     # Returns shell true if <flag> is supported by the Fortran 90 compiler, else returns shell false.
420     test-flag-FC() { test-flag-PROG "FC" "$1"; }
421    
422 azarah 1.99 test-flags-PROG() {
423     local comp=$1
424     local flags
425 azarah 1.96 local x
426 azarah 1.99
427     shift
428    
429 vapier 1.113 [[ -z ${comp} ]] && return 1
430 swegener 1.101
431 vapier 1.113 x=""
432 azarah 1.96 for x in "$@" ; do
433 vapier 1.113 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
434 azarah 1.96 done
435    
436 azarah 1.99 echo "${flags}"
437 azarah 1.96
438 azarah 1.99 # Just bail if we dont have any flags
439     [[ -n ${flags} ]]
440 azarah 1.96 }
441    
442 vapier 1.121 # @FUNCTION: test-flags-CC
443     # @USAGE: <flags>
444     # @DESCRIPTION:
445     # Returns shell true if <flags> are supported by the C compiler, else returns shell false.
446 azarah 1.99 test-flags-CC() { test-flags-PROG "CC" "$@"; }
447    
448 vapier 1.121 # @FUNCTION: test-flags-CXX
449     # @USAGE: <flags>
450     # @DESCRIPTION:
451     # Returns shell true if <flags> are supported by the C++ compiler, else returns shell false.
452 azarah 1.99 test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
453    
454 dberkholz 1.124 # @FUNCTION: test-flags-F77
455     # @USAGE: <flags>
456     # @DESCRIPTION:
457     # Returns shell true if <flags> are supported by the Fortran 77 compiler, else returns shell false.
458     test-flags-F77() { test-flags-PROG "F77" "$@"; }
459    
460     # @FUNCTION: test-flags-FC
461     # @USAGE: <flags>
462     # @DESCRIPTION:
463     # Returns shell true if <flags> are supported by the Fortran 90 compiler, else returns shell false.
464     test-flags-FC() { test-flags-PROG "FC" "$@"; }
465    
466 vapier 1.121 # @FUNCTION: test-flags
467     # @USAGE: <flags>
468     # @DESCRIPTION:
469 azarah 1.99 # Short-hand that should hopefully work for both C and C++ compiler, but
470 azarah 1.100 # its really only present due to the append-flags() abomination.
471 azarah 1.99 test-flags() { test-flags-CC "$@"; }
472    
473 vapier 1.121 # @FUNCTION: test_flag
474     # @DESCRIPTION:
475     # DEPRICIATED, use test-flags()
476 vapier 1.36 test_flag() {
477 kevquinn 1.104 ewarn "test_flag: deprecated, please use test-flags()!" >&2
478 azarah 1.96
479 azarah 1.99 test-flags-CC "$@"
480 puggy 1.29 }
481    
482 vapier 1.121 # @FUNCTION: test_version_info
483     # @USAGE: <version>
484     # @DESCRIPTION:
485     # Returns shell true if the current C compiler version matches <version>, else returns shell false.
486     # Accepts shell globs.
487 agriffis 1.58 test_version_info() {
488 vapier 1.75 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
489 agriffis 1.58 return 0
490     else
491     return 1
492     fi
493     }
494    
495 vapier 1.121 # @FUNCTION: strip-unsupported-flags
496     # @DESCRIPTION:
497 dberkholz 1.124 # Strip {C,CXX,F,FC}FLAGS of any flags not supported by the active toolchain.
498 puggy 1.29 strip-unsupported-flags() {
499 vapier 1.113 export CFLAGS=$(test-flags-CC ${CFLAGS})
500     export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
501 dberkholz 1.124 export FFLAGS=$(test-flags-F77 ${FFLAGS})
502     export FCFLAGS=$(test-flags-FC ${FCFLAGS})
503 azarah 1.8 }
504    
505 vapier 1.121 # @FUNCTION: get-flag
506     # @USAGE: <flag>
507     # @DESCRIPTION:
508     # Find and echo the value for a particular flag. Accepts shell globs.
509 vapier 1.10 get-flag() {
510 agriffis 1.58 local f findflag="$1"
511    
512 vapier 1.36 # this code looks a little flaky but seems to work for
513     # everything we want ...
514     # for example, if CFLAGS="-march=i686":
515 agriffis 1.58 # `get-flag -march` == "-march=i686"
516     # `get-flag march` == "i686"
517 dberkholz 1.124 for f in ${CFLAGS} ${CXXFLAGS} ${FFLAGS} ${FCFLAGS} ; do
518 vapier 1.10 if [ "${f/${findflag}}" != "${f}" ] ; then
519 agriffis 1.58 printf "%s\n" "${f/-${findflag}=}"
520 vapier 1.28 return 0
521 vapier 1.10 fi
522     done
523 vapier 1.28 return 1
524 joker 1.16 }
525    
526 vapier 1.121 # @FUNCTION: has_hardened
527     # @DESCRIPTION:
528 kevquinn 1.92 # DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
529 solar 1.53 has_hardened() {
530 kevquinn 1.104 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
531 swegener 1.101
532 lv 1.69 test_version_info Hardened && return 0
533 azarah 1.96 # The specs file wont exist unless gcc has GCC_SPECS support
534     [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
535 solar 1.53 }
536    
537 vapier 1.121 # @FUNCTION: has_pic
538     # @DESCRIPTION:
539 kevquinn 1.92 # DEPRECATED - use gcc-specs-pie from toolchain-funcs
540 solar 1.81 # indicate whether PIC is set
541 tseng 1.42 has_pic() {
542 kevquinn 1.104 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
543 swegener 1.101
544 azarah 1.96 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
545 kevquinn 1.105 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
546     gcc-specs-pie
547 tseng 1.42 }
548    
549 vapier 1.121 # @FUNCTION: has_pie
550     # @DESCRIPTION:
551 kevquinn 1.92 # DEPRECATED - use gcc-specs-pie from toolchain-funcs
552 solar 1.81 # indicate whether PIE is set
553 mr_bones_ 1.83 has_pie() {
554 kevquinn 1.104 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
555 swegener 1.101
556 azarah 1.96 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
557 kevquinn 1.105 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
558     gcc-specs-pie
559 tseng 1.42 }
560 mr_bones_ 1.83
561 vapier 1.121 # @FUNCTION: has_ssp_all
562     # @DESCRIPTION:
563 kevquinn 1.92 # DEPRECATED - use gcc-specs-ssp from toolchain-funcs
564 solar 1.86 # indicate whether code for SSP is being generated for all functions
565     has_ssp_all() {
566 kevquinn 1.104 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
567 swegener 1.101
568 solar 1.86 # note; this matches only -fstack-protector-all
569 azarah 1.96 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
570     -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
571 gengor 1.130 gcc-specs-ssp-to-all
572 solar 1.86 }
573    
574 vapier 1.121 # @FUNCTION: has_ssp
575     # @DESCRIPTION:
576 kevquinn 1.92 # DEPRECATED - use gcc-specs-ssp from toolchain-funcs
577 solar 1.81 # indicate whether code for SSP is being generated
578 tseng 1.42 has_ssp() {
579 kevquinn 1.104 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
580 swegener 1.101
581 solar 1.81 # note; this matches both -fstack-protector and -fstack-protector-all
582 azarah 1.96 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
583     -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
584     gcc-specs-ssp
585 tseng 1.42 }
586    
587 vapier 1.121 # @FUNCTION: has_m64
588     # @DESCRIPTION:
589     # This doesn't test if the flag is accepted, it tests if the flag actually
590     # WORKS. Non-multilib gcc will take both -m32 and -m64. If the flag works
591     # return code is 0, else the return code is 1.
592 lv 1.56 has_m64() {
593 lv 1.62 # this doesnt test if the flag is accepted, it tests if the flag
594     # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
595     # please dont replace this function with test_flag in some future
596     # clean-up!
597 swegener 1.101
598 vapier 1.72 local temp="$(emktemp)"
599 azarah 1.96 echo "int main() { return(0); }" > "${temp}".c
600 kugelfang 1.74 MY_CC=$(tc-getCC)
601 azarah 1.96 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
602 vapier 1.72 local ret=$?
603 azarah 1.96 rm -f "${temp}".c
604     [[ ${ret} != 1 ]] && return 0
605 lv 1.62 return 1
606 lv 1.56 }
607    
608 vapier 1.121 # @FUNCTION: has_m32
609     # @DESCRIPTION:
610     # This doesn't test if the flag is accepted, it tests if the flag actually
611     # WORKS. Non-mulilib gcc will take both -m32 and -64. If the flag works return
612     # code is 0, else return code is 1.
613 lv 1.56 has_m32() {
614 lv 1.62 # this doesnt test if the flag is accepted, it tests if the flag
615     # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
616     # please dont replace this function with test_flag in some future
617     # clean-up!
618 eradicator 1.80
619     [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
620    
621 vapier 1.95 local temp=$(emktemp)
622     echo "int main() { return(0); }" > "${temp}".c
623 kugelfang 1.74 MY_CC=$(tc-getCC)
624 vapier 1.95 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
625 vapier 1.72 local ret=$?
626 vapier 1.95 rm -f "${temp}".c
627 azarah 1.96 [[ ${ret} != 1 ]] && return 0
628 lv 1.62 return 1
629 lv 1.56 }
630    
631 vapier 1.121 # @FUNCTION: replace-sparc64-flags
632     # @DESCRIPTION:
633     # Sets mcpu to v8 and uses the original value as mtune if none specified.
634 vapier 1.18 replace-sparc64-flags() {
635 fmccor 1.98 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
636 joker 1.16
637 mr_bones_ 1.83 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
638 agriffis 1.58 for x in ${SPARC64_CPUS}; do
639 joker 1.16 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
640     done
641 mr_bones_ 1.83 else
642 swegener 1.111 for x in ${SPARC64_CPUS}; do
643 joker 1.16 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
644     done
645     fi
646 mr_bones_ 1.83
647     if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
648 agriffis 1.58 for x in ${SPARC64_CPUS}; do
649 joker 1.16 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
650     done
651     else
652 swegener 1.111 for x in ${SPARC64_CPUS}; do
653 joker 1.16 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
654     done
655     fi
656 vapier 1.59
657     export CFLAGS CXXFLAGS
658 solar 1.27 }
659    
660 vapier 1.121 # @FUNCTION: append-ldflags
661     # @USAGE: <flags>
662     # @DESCRIPTION:
663     # Add extra <flags> to the current LDFLAGS.
664 solar 1.27 append-ldflags() {
665 kevquinn 1.105 [[ -z $* ]] && return 0
666 flameeyes 1.123 local flag
667     for flag in "$@"; do
668     [[ ${flag} == -l* ]] && \
669     ewarn "Appending a library link instruction (${flag}); libraries to link to should not be passed through LDFLAGS"
670     done
671    
672 vapier 1.59 export LDFLAGS="${LDFLAGS} $*"
673 vapier 1.28 return 0
674 solar 1.27 }
675    
676 vapier 1.121 # @FUNCTION: filter-ldflags
677     # @USAGE: <flags>
678     # @DESCRIPTION:
679     # Remove particular <flags> from LDFLAGS. Accepts shell globs.
680 solar 1.41 filter-ldflags() {
681 kevquinn 1.105 _filter-var LDFLAGS "$@"
682 solar 1.41 return 0
683     }
684    
685 vapier 1.121 # @FUNCTION: raw-ldflags
686     # @USAGE: <flags>
687     # @DESCRIPTION:
688 kevquinn 1.105 # Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
689     # are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
690     # to gcc where it needs the '-Wl,'.
691 vapier 1.102 raw-ldflags() {
692     local x input="$@"
693     [[ -z ${input} ]] && input=${LDFLAGS}
694     set --
695     for x in ${input} ; do
696 vapier 1.103 x=${x#-Wl,}
697     set -- "$@" ${x//,/ }
698 vapier 1.102 done
699     echo "$@"
700     }
701    
702 vapier 1.121 # @FUNCTION: bindnow-flags
703     # @RETURN: Returns the flags to enable "now" binding in the current selected linker.
704     # @DESCRIPTION:
705     # DEPRECATED - Gets the flags needed for "NOW" binding
706 flameeyes 1.94 bindnow-flags() {
707 vapier 1.129 ewarn "QA: stop using the bindnow-flags function ... simply drop it from your ebuild"
708 flameeyes 1.94 }
709 vapier 1.113
710    
711     # Some tests for when we screw with things and want to make
712     # sure we didn't break anything
713     #TESTS() {
714     # CFLAGS="-a -b -c=1"
715     # CXXFLAGS="-x -y -z=2"
716     # LDFLAGS="-l -m -n=3"
717     #
718     # die() { exit 1; }
719     # (is-flag 1 2 3) && die
720     # (is-ldflag 1 2 3) && die
721     #
722     # is-flagq -l && die
723     # is-ldflagq -a && die
724     # is-flagq -a || die
725     # is-flagq -x || die
726     # is-ldflagq -n=* || die
727     # is-ldflagq -n && die
728     #
729     # strip-unsupported-flags
730     # [[ ${CFLAGS} == "-c=1" ]] || die
731     # [[ ${CXXFLAGS} == "-y -z=2" ]] || die
732     #
733     # echo "All tests pass"
734     #}
735     #TESTS

  ViewVC Help
Powered by ViewVC 1.1.20